#!/bin/sh
# Copyright (C) 2001 Cyberdude47
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# ------------------------------------------------------------------------
#               ADSL4Linux installatie programma
# ------------------------------------------------------------------------
#
# $Id: install.sh,v 4.1 2003/11/27 09:26:22 bill Exp $
#
# Installatie script voor ADSL gebruikers.
#
# Homepage at: http://www.adsl4linux.nl
# -----------------------------------------------------------------------
# VARIABLES DECLARATION
# -----------------------------------------------------------------------

# VERSION SPECIFIC
VERS="1.09a";
DATE="23-03-2002";

# FIXED VARIABLES
datum=`date +'%b %d %H:%M:%S'`;
date2=`date +'%b%d-%H:%M'`;

# BASE DIRECTORIES
# Install Directory
if [ -z $1 ] 
then
{
PATH_BASE="/usr/local";
}
else
{
PATH_BASE="$1";
}
fi;

MY_PATH="$PATH_BASE/ADSL4Linux";

# Package Directory
PACK_BASE=`echo $0 | awk 'BEGIN { FS = "/"; RS = "" } { print $1 }' `;
if [ "$PACK_BASE" = "." ]
then :
else
PACK_BASE=`echo $0 | awk '{ i= split ($0,var,"/") } END { for (k=2; k<i; k++) printf ("/%s", var[k]) }'`;
cd $PACK_BASE
fi;

#Working Directory
WD=`pwd`;

# Directories
t="templates";
f="files";
b="bin";

# -----------------------------------------------------------
# FILES
# -----------------------------------------------------------
# Fixed files
PACKAGE="ADSL4Linux-$VERS.tar.gz";
INSTALLOG="/var/log/adsl4linux.log";

# Templates
pap="$MY_PATH/$t/pap-secrets.template";
options="$MY_PATH/$t/options.adsl.template";


# Binaries
pptp="$MY_PATH/$b/pptp";
adsl="$MY_PATH/$b/adsl";
usage="$MY_PATH/$b/usage";
musage="$MY_PATH/$b/monthlyusage.sh";
# ----------------------------------------------------------
# OTHER VARIABLES
# ----------------------------------------------------------

me=`whoami`;

# ----------------------------------------------------------
# FUNCTIONS
# ----------------------------------------------------------

function proccheck
{
if [ -x "/sbin/$1" ]
then
{
echo "$1 file is executable, no copy needed";
}
else
{
echo "$1 file doesn't exist, copying";
cp /$MY_PATH/$b/$1 /sbin/$1 | tee -a $INSTALLOG;
}
fi;
}


# ----------------------------------------------------------
# MAIN PROGRAM
# ----------------------------------------------------------

start(){
if [ "$me" != "root" ]; then
clear;
echo; echo; echo;
echo -e "\033[40m\033[1;31mU moet inlogd zijn als 'root'!\033[0m";
do_exit;
else
begin;
fi;
}

begin() {
clear;
titel;
echo "$datum - Start ADSL4Linux versie $VERS" >> $INSTALLOG;
START="Installatie Wijzigen_Gegevens Tools Stoppen";
echo;
echo "Maak uw keuze";
select keuze in $START; do
if [ "$keuze" = "Installatie" ];
then
untar;
data;
elif [ "$keuze" = "Wijzigen_Gegevens" ];
then
untar;
data;
elif [ "$keuze" = "Tools" ];
then
untar;
tools;
clear;
titel;
elif [ "$keuze" = "Stoppen" ];
then
do_exit;
else
clear;
echo "Maak uw keuze";
fi;
done
}



titel() {
clear;
echo;
echo -e "\033[40m\033[1;34m            Welkom bij de installatie van ADSL4Linux $VERS\033[0m";
echo;
echo "--------------------------------------------------------------------------";
echo "Dit programma installeert de files die nodig zijn om een MXStream-verbinding"
echo "te maken onder Linux."
echo "--------------------------------------------------------------------------";
echo "- U moet ingelogd zijn als 'root'! Of U moet handmatig kopieren.";
echo "- Houdt uw MXStream gegevens bij de hand.";
echo " DEZE INSTALLATIE BESTAAT UIT 4 STAPPEN.";
}


untar() {
if [ -e $PACKAGE ]
then
{
       echo;
        echo "Start van uitpakken van het tar.gz bestand.";
	cd $PATH_BASE;
        echo "`tar -xvzf $WD/$PACKAGE` $datum" | tee -a $INSTALLOG;
	echo "Bestanden uitgepakt naar $MY_PATH";
	cd $WD;
        echo "Bezig met het zetten van de rechten bestaande bestanden.";
        chmod 755 $pptp >> $INSTALLOG;
	chown -R root $MY_PATH;
	chmod -R 600 $MY_PATH/files;
	chmod -R 700 $MY_PATH/bin;
}
else
{
	echo;
	echo -e "\033[40m\033[1;31mERROR:\033[0m Bestand $PACKAGE mist.";
	echo "Installatie afgebroken.";
	do_exit;
}
fi;
}

data() {
echo;
echo "Stap 2: Vul uw nieuwe gegevens in.";
echo "-----------------------------------------------------";
echo "(uw inlognaam is bv gebruiker@isp-snelheid).";
echo "GEEN EMAIL ADRES INVULLEN!";
echo "Deze volledig invullen.";
echo $N "Vul uw inlognaam in: $C"; read name;
echo $N "Vul uw wachtwoord in: $C"; read password;
echo;
echo "De door u ingevulde gegevens zijn:";
echo "Inlognaam: $name";
echo "Wachtwoord: $password";
echo;
echo "Zijn deze gegevens correct?";

CHECK="Doorgaan Wijzigen";
select ChCk in $CHECK; do
if [ "$ChCk" = "Wijzigen" ];
then
    data;
else

sed "s/_NAME_/$name/g" $pap > temp;
sed "s/_PASSWORD_/$password/g"  temp > $MY_PATH/$f/pap-secrets;
sed "s/_NAME_/$name/g" $options > $MY_PATH/$f/adsl;
rm -f temp;
chmod -R 600 $MY_PATH/files;
copy;
fi;
done
}

copy() {
echo;
echo "Stap 3: Bestanden kopieren naar de juiste locatie";
echo -e "\033[40m\033[1;31m!!!! LET OP ALS U GEEN ROOT BENT KIES DAN STOPPEN !!!!\033[0m";
echo "-------------------------------------------------------";
echo "Wilt U de bestanden kopieren of wilt u stoppen om het handmatig te doen?";
COPYOPT="Kopieren Stoppen";
select copy in $COPYOPT; do
if [ "$copy" = "Kopieren" ];
then
echo "Start van kopieren."

cp /etc/ppp/pap-secrets /etc/ppp/pap-secrets.adsl4linuxbackup$date2;
cp $MY_PATH/files/pap-secrets /etc/ppp/pap-secrets;
cp $adsl /usr/sbin/adsl | tee -a $INSTALLOG;
cp $pptp /usr/sbin/pptp | tee -a $INSTALLOG;
cp $usage /usr/sbin/usage | tee -a $INSTALLOG;
cp $musage /etc/cron.monthly | tee -a $INSTALLOG;
# Check if dir exists
if [ -d "/etc/ppp/peers" ]
then :
else
{
mkdir /etc/ppp/peers;
}
fi;

cp $MY_PATH/files/adsl /etc/ppp/peers/adsl | tee -a $INSTALLOG;

cp $MY_PATH/$b/ppptime /usr/sbin/ppptime | tee -a $INSTALLOG;

#check if checkproc etc exist and if not copy them.
proccheck "checkproc";
proccheck "startproc";
proccheck "killproc";

echo;

echo "Klaar met kopieren, installatie is voltooid!";

connect;

elif [ "$copy" = "Stoppen" ];
then
        do_exit;
else
    clear;
    echo;
    echo "Stap 3: Bestanden kopieren naar de juiste locatie";
    echo -e "\033[40m\033[1;31m!!!! LET OP ALS U GEEN ROOT BENT KIES DAN STOPPEN !!!!\033[0m";
    echo "-------------------------------------------------------";
    echo "Wilt U de bestanden kopieren of wilt u stoppen om het handmatig te doen?";
fi;
done
do_exit;
}


do_exit() {
echo;
echo;
echo "---------------------------------------------------";
echo "Versie $VERS, $DATE";
echo;
echo "Bugs/ suggesties mailen naar: cyberdude47@hotmail.com";
echo;
echo "Problemen? Kijk op de website: http://www.adsl4linux.nl";
echo;
echo "Om in te loggen tik in 'adsl start'";
echo "Om uit te loggen tik in 'adsl stop'";
echo;
exit;
}

tools() {
cd $MY_PATH;
./tools.sh;
}

connect() {
echo ;
echo "----------------------------------------------------------------------";
echo "Stap 4: Wilt U nu verbinding leggen met uw MXStream account?";
echo "Kies Nee als U terug wilt gaan naar het hoofdmenu.";
echo "Kies voor Ja als U verbinding wilt maken en het programma wilt verlaten.";
echo "Extra gebruikers let op: er wordt ingelogd met pc1!";
echo "-----------------------------------------------------------------------";
CONNECT="Ja Nee";
select verbindme in $CONNECT; do
if [ "$verbindme" = "Ja" ];
then
echo "De verbinding wordt nu gemaakt, mits alles juist is ingesteld.";
/usr/sbin/adsl start | tee -a $INSTALLOG;
do_exit;
elif [ "$verbindme" = "Nee" ]; then
start;
else
clear;
echo "Wilt U nu verbinding maken?";
fi;
done
}

check(){
KANS1=`/sbin/ifconfig eth0 | awk '/inet addr:/ {print $2}' | awk ' { split ($0,var, ":") } END { print var[2] }' | awk ' { split ($0, var, ".") } END { print var[1] } '`;
KANS2=`/sbin/ifconfig eth1 | awk '/inet addr:/ {print $2}' | awk ' { split ($0,var, ":") } END { print var[2] }' | awk ' { split ($0, var, ".") } END { print var[1] } '`;
IPCHK="10"

if [ $KANS1 -eq $IPCHK ] || [ $KANS2 -eq $IPCHK ]
then
    start;
else
    echo;
    echo -e "\033[40m\033[1;31m  Heeft U wel een netwerkkaart met IP adres dat ligt in de range\033[0m";
    echo -e "\033[40m\033[1;31m  $IPCHK.XXX.XXX.XXX - $IPCHK.XXX.XXX.XXX?\033[0m";
    echo;
    do_exit;
fi;
}

# Hier begint het programma.
# Problemen? Zet CHECK uit en START aan!
#start;
check;

#als je geen root bent deze aanzetten:
#begin;
